//*****************************************************************************
//*****************************************************************************
//  FILENAME: DTM.h
//   Version: 1.5, Updated on 2013/5/19 at 10:43:28
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION:
//    C declarations for the DTMFDialer User Module.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef DTM_INCLUDE
#define DTM_INCLUDE

#include <M8C.h>

//-------------------------------------------------
// Defines for DTM API's.
//-------------------------------------------------
#define DTM_OFF                        0
#define DTM_LOWPOWER                   1
#define DTM_MEDPOWER                   2
#define DTM_HIGHPOWER                  3
#define  DTMF_READFRROM                1                   //Phone number is stored in ROM/Flash
#define  DTMF_DIALING                  2                   //Phone dialing is in progress
#define  DTMF_CONTINUOUS_TONE          4                   //tones have infinite duration

#define  DTM_BACKGROUND_ENABLE  0x1 & 0x01
#define  DTM_FOREGROUND_ENABLE  0x1 & 0x02


#pragma fastcall16  DTM_Start
#pragma fastcall16  DTM_StartSamples
#pragma fastcall16  DTM_SetPower
#pragma fastcall16  DTM_Stop
#pragma fastcall16  DTM_StopSamples
#pragma fastcall16  DTM_DialFromRam
#pragma fastcall16  DTM_DialFromRom
#pragma fastcall16  DTM_DialDigit
#pragma fastcall16  DTM_bReadStatus
#pragma fastcall16 bDTM_ReadStatus

//-------------------------------------------------
// Prototypes of the DTM API.
//-------------------------------------------------
extern void  DTM_Start(BYTE bPower);
extern void  DTM_StartSamples(void);
extern void  DTM_SetPower(BYTE bPower);
extern void  DTM_Stop(void);
extern void  DTM_StopSamples(void);
extern void  DTM_DialFromRam(char * sRamString);
extern void  DTM_DialFromRom(const char * sRomString);
extern void  DTM_DialDigit(BYTE bDigit);
extern BYTE  DTM_bReadStatus(void);
extern BYTE bDTM_ReadStatus(void);   // Do not use

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------
#pragma ioport  DTM_DACcr0: 0x08c
BYTE            DTM_DACcr0;
#pragma ioport  DTM_DACcr1: 0x08d
BYTE            DTM_DACcr1;
#pragma ioport  DTM_DACcr2: 0x08e
BYTE            DTM_DACcr2;
#pragma ioport  DTM_DACcr3: 0x08f
BYTE            DTM_DACcr3;
#pragma ioport  DTM_DTMF_ClkFN: 0x120
BYTE            DTM_DTMF_ClkFN;
#pragma ioport  DTM_DTMF_ClkSL: 0x121
BYTE            DTM_DTMF_ClkSL;
#pragma ioport  DTM_DTMF_ClkOS: 0x122
BYTE            DTM_DTMF_ClkOS;
#pragma ioport  DTM_DTMF_ClkDR0:    0x020
BYTE            DTM_DTMF_ClkDR0;
#pragma ioport  DTM_DTMF_ClkDR1:    0x021
BYTE            DTM_DTMF_ClkDR1;
#pragma ioport  DTM_DTMF_ClkDR2:    0x022
BYTE            DTM_DTMF_ClkDR2;
#pragma ioport  DTM_DTMF_ClkCR0:    0x023
BYTE            DTM_DTMF_ClkCR0;

//-------------------------------------------------
// Defines for DTM API's.
//-------------------------------------------------
//  State Definitions
#define   S_TONE             0
#define   S_TONESPACE        2
#define   S_GETDIG           4
#define   S_DECODE           6
#define   S_LAUNCH           8
#define   S_CONTTONE         10
#define   S_ENDCONT          12
#define   S_IDLE             14

#endif
// end of file DTM.h
