// ///////////////////////////////////////////////////////////////////
#include "Global.h"   
#include "DTMF.h"
// ///////////////////////////////////////////////////////////////////
volatile byte DTMF_data;
// ///////////////////////////////////////////////////////////////////
byte DTMF_Code[16] =
{	'd', '1', '2', '3',
 	'4', '5', '6', '7',
 	'8', '9', '0', '*',
 	'#', 'a', 'b', 'c'
};	
// ///////////////////////////////////////////////////////////////////
#define  DTMF_BUF_SIZE 32
volatile byte DtFlag, DtIdx;
volatile byte DtBuf[DTMF_BUF_SIZE];
// ///////////////////////////////////////////////////////////////////
void EnterDTMF(void)
{	M8C_DisableGInt;       	// disable global interrupts
	UART_DisableInt();
	DTMFEnable();
	M8C_EnableGInt;       	// enable global interrupts
}
// ///////////////////////////////////////////////////////////////////
void ExitDTMF(void)
{	M8C_DisableGInt;       	// disable global interrupts
	UART_EnableInt();
	M8C_EnableGInt;       	// enable global interrupts
}
// ///////////////////////////////////////////////////////////////////
void EnterUART(void)
{	M8C_DisableGInt;       	// disable global interrupts
	UART_EnableInt();
	DTMFDisable();
	M8C_EnableGInt;       	// enable global interrupts
}
// ///////////////////////////////////////////////////////////////////
void ExitUART(void)
{	M8C_DisableGInt;       	// disable global interrupts
	DTMFEnable();
	M8C_EnableGInt;       	// enable global interrupts
}
// ///////////////////////////////////////////////////////////////////
#pragma interrupt_handler  GPIO_ISRC
void GPIO_ISRC(void)
{ byte code;   
	if( QS_Data_ADDR&QS_MASK )			// DTMF data ready
	{	if( DtFlag<2 && DTMF_data==0 )
		{	EnterDTMF();	
			code= 0;
			if( !(Q1_Data_ADDR & Q1_MASK) ) code|= 1;
	 		if( !(Q2_Data_ADDR & Q2_MASK) ) code|= 2;
	 		if( !(Q3_Data_ADDR & Q3_MASK) ) code|= 4;
	 		if( !(Q4_Data_ADDR & Q4_MASK) ) code|= 8;
			code= DTMF_Code[code];
			DtBuf[DtIdx++]= code;
			if( DtIdx>=DTMF_BUF_SIZE-1 ) DtIdx= DTMF_BUF_SIZE-1;
			TimeOut= 150;
			DTMF_data= 1;
			DtFlag= 1;
			LED_ON;
	}	}
	else			// fall edge
	{	DTMF_data= 0;   // clear if complete
	}
}

// ///////////////////////////////////////////////////////////////////
#pragma interrupt_handler  SLEEP_ISRC
void SLEEP_ISRC(void)
{
	SystemTimer+= SLEEP_PRIOD;		// every period
	if( TimeOut>0 )
	{	TimeOut-= SLEEP_PRIOD;
		if( TimeOut<=0 )
		{	TimeOut= 0;
			if( DtFlag==1 )
			{	DtFlag= 2;
				ExitDTMF();	
			}
	}	}
}

// ///////////////////////////////////////////////////////////////////
byte DTMF_Receive( byte rec[], byte siz )
{ byte len;
	if( DtFlag<2 ) return 0;
	if( siz>=DTMF_BUF_SIZE-1 ) siz= DTMF_BUF_SIZE-1;  
	len= DtIdx;
	if( siz<len ) len= siz;
	strncpy( rec, (char*)DtBuf, len );
	rec[len]= 0;
	DtFlag= 0;
	DtIdx= 0;
	LED_OFF;
	return len;  
}

// ///////////////////////////////////////////////////////////////////
void DTMFEnable(void)
{	DTMF_data= 0;
	ON( QS_IntEn_ADDR, QS_MASK );
	DtFlag= 0;
	DtIdx= 0;
}
// ///////////////////////////////////////////////////////////////////
void DTMFDisable(void)
{	OFF( QS_IntEn_ADDR, QS_MASK );
}
// ///////////////////////////////////////////////////////////////////
void DTMF_Restart(void)
{
	DTM_Stop();
	DTM_Start(DTM_HIGHPOWER);
	DTM_StartSamples();
	DTMFEnable();
}
// ///////////////////////////////////////////////////////////////////