// ///////////////////////////////////////////////////////////////////
#ifndef _GLOBAL_H_
#define _GLOBAL_H_
// ///////////////////////////////////////////////////////////////////
#include <m8c.h>          // part specific constants and macros
#include  "PSoCAPI.h"     // PSoC API definitions for all User Modules
#include  "PSoCGPIOINT.h"
#include <string.h>
#include <stdlib.h>
// ///////////////////////////////////////////////////////////////////
#define  true   -1
#define  false  0
// ///////////////////////////////////////////////////////////////////
typedef unsigned char   byte;
typedef unsigned short  word;
// ///////////////////////////////////////////////////////////////////
#define SLEEP_FREQ  500					// Hz
#define SLEEP_PRIOD (1000/SLEEP_FREQ)	// mili sec
extern 	volatile long  SystemTimer;
extern 	volatile int   TimeOut; 
// ///////////////////////////////////////////////////////////////////
void PSoCSleep(void);
void SystemTimerStart(void);
void Sleep( long ms );
void SLEEP( void );
void WaitMs( int n );	// n m.sec at 24MHz clock
void Wait( int n );		// n u.sec at 24MHz clock
void WheelMark( int cw );
byte Switch(void);
// ///////////////////////////////////////////////////////////////////
#define ON( port, mask) (port) |= (mask)
#define OFF(port, mask) (port) &= (~mask)
#define On( port, bit) (port) |=  (1 << (bit))
#define Off(port, bit) (port) &= ~(1 << (bit))
// ///////////////////////////////////////////////////////////////////
#define LED_ON		(LED_Data_ADDR |= LED_MASK)
#define LED_OFF		(LED_Data_ADDR &= ~LED_MASK)
#define LED_TOG		(LED_Data_ADDR ^= LED_MASK)
// ///////////////////////////////////////////////////////////////////
   enum ASCII
   {	NUL=	0x00,
   		STX  =	0x02,
   		ETX  =	0x03,
   		CR  =	0x0D,
		ACK=	0x06,
		NAK=	0x15,
		SYN=	0x16,
		ESC=	0x1B,
		SPC=	0x20
	};
// ///////////////////////////////////////////////////////////////////
#endif
// ///////////////////////////////////////////////////////////////////
