;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: DTM.inc
;;   Version: 1.5, Updated on 2013/5/19 at 10:43:28
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION:
;;    Assembler declarations for the DTMF Dialer
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************



;--------------------------------------------------
; Register constants and masks
;--------------------------------------------------
S_TONE:              equ 0
S_TONESPACE:         equ 2
S_GETDIG:            equ 4
S_DECODE:            equ 6
S_LAUNCH:            equ 8
S_CONTTONE:          equ 10
S_ENDCONT:           equ 12
S_IDLE:              equ 14
NOSTATE:             equ ~3fh


iNoToneLength:      equ ((DTMFClkFreq * 9)/10)
iToneOnLength:      equ ((DTMFClkFreq * DTMFToneDuration)/1000)
iToneOffLength:     equ ((DTMFClkFreq * DTMFToneSpacing)/1000)



DTM_DTMFMask:    equ  01h
DTM_OFF:         equ  0
DTM_LOWPOWER:    equ  1
DTM_MEDPOWER:    equ  2
DTM_HIGHPOWER:   equ  3
HighByte:                     equ  0
LowByte:                      equ  1

DTMFClkFreq:                  equ 7d00h
DTMFToneDuration:             equ 28h
DTMFToneSpacing:              equ 28h
DTMF_READFRROM:               equ  1                         ;Phone number is stored in ROM/Flash
DTMF_DIALING:                 equ  2                         ;Phone dialing is in progress
DTMF_CONTINUOUS_TONE:         equ  4                         ;tones have infinite duration
DTMF_INTERRUPT_TICK:          equ  0x80                      ;use to signal that there was an interrupt
DTMF_DATA_INVALID:            equ  0x40                      ;use to signal that there was an interrupt

;
;flag to use as an equate for Foreground conditional compile
;

DTM_BACKGROUND_ENABLE::                     equ 1h & 01
DTM_FOREGROUND_ENABLE::                     equ 1h & 02

;--------------------------------------------------
; Registers used by DTM
;--------------------------------------------------

DTM_DACcr0: equ 8ch
DTM_DACcr1: equ 8dh
DTM_DACcr2: equ 8eh
DTM_DACcr3: equ 8fh
DTM_DTMF_ClkFN: equ 20h
DTM_DTMF_ClkSL: equ 21h
DTM_DTMF_ClkOS: equ 22h
DTM_DTMF_ClkDR0:    equ 20h
DTM_DTMF_ClkDR1:    equ 21h
DTM_DTMF_ClkDR2:    equ 22h
DTM_DTMF_ClkCR0:    equ 23h

;; end of file DTM.inc
